"""
MIT License

Copyright (c) 2018 Rafael Felix Alves

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"""
import argparse
def str2list(v):
    import re
    return list([var.replace('\'', '') for var in re.search(r'\[(.*)\]', v).group(1).split(',')])

def str2strlist(v):
    values = ''.join(''.join(v.split("[")).split("]"))
    values = ''.join(''.join(values.split("(")).split(")"))
    values = ','.join(values.split(', ')).split(',')
    return list(values)

def str2intlist(v):
    values = ''.join(''.join(v.split("[")).split("]"))
    values = ''.join(''.join(values.split("(")).split(")"))
    values = ','.join(values.split(', ')).split(',')
    return list([int(value) for value in values])

def str2array(v, rtype=int):
    import re
    import numpy as np
    return np.array([var.replace('\'', '') for var in re.search(r'\[(.*)\]', v).group(1).split(',')]).astype(rtype)

def str2bool(v):
    if v.lower() in ('yes', 'true', 't', 'y', '1'):
        return True
    elif v.lower() in ('no', 'false', 'f', 'n', '0'):
        return False
    else:
        raise argparse.ArgumentTypeError('Boolean value expected.')